# This document runs only once at the beginning of the app.

# Declare a root path to files for ITHIM TOOL.
pth <- "tool_files"

# Load Libraries
if(!("shiny" %in% .packages()))  # is it already loaded in workspace?
  if(require(shiny) ==  F) {  # load it, but if you can't...
    install.packages("shiny")  # install it.
    library(shiny)  # try loading it again.
  }
if(!("digest" %in% .packages()))  # is it already loaded in workspace?
  if(require(digest) ==  F) {  # load it, but if you can't...
    install.packages("digest")  # install it.
    library(digest)  # try loading it again.
  }
if(!("rmarkdown" %in% .packages()))  # is it already loaded in workspace?
  if(require(rmarkdown) ==  F) {  # load it, but if you can't...
    install.packages("rmarkdown")  # install it.
    library(rmarkdown)  # try loading it again.
  }
if(!("grid" %in% .packages()))  # is it already loaded in workspace?
  if(require(grid) ==  F) {  # load it, but if you can't...
    install.packages("grid")  # install it.
    library(grid)  # try loading it again.
  }
if(!("png" %in% .packages()))  # is it already loaded in workspace?
  if(require(png) ==  F) {  # load it, but if you can't...
    install.packages("png")  # install it.
    library(png)  # try loading it again.
  }

# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Load source for ITHIM TOOL.
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Functions to be used in the Analytic Engine of the ITHIM TOOL.
source(file.path(pth, "ithim_functions.R")) 
# Functions to be used in the Shiny part of the ITHIM TOOL.
source(file.path(pth, "shiny_functions.R"))
# *One-time* loading of csvs and pngs, as well as a few operations.
source(file.path(pth, "preprocessing.R")) 
# Largely functions for table/graph/infographic creation.
source(file.path(pth, "visualization.R")) 
# ITHIM TOOL's Shiny code.
source(file.path(pth, "tool_modules.R"))  